package Servidor;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.ArrayList;

public class ServidorThread extends Thread {

    private Socket conexao;
    private ArrayList<ObjectOutputStream> outrosClientes;
    private Logica l;
    private ArrayList<Jogador> j;
    private int cod;
    private int a;

    public ServidorThread(Socket c, ArrayList<ObjectOutputStream> saidaDosClientes, Logica l, ArrayList<Jogador> j) {
        this.conexao = c;
        this.outrosClientes = saidaDosClientes;
        this.l = l;
        this.j = j;

    }

    @Override
    public void run() {
        ObjectOutputStream saida;
        ObjectInputStream entrada;

        try {

            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());
            this.outrosClientes.add(saida);
            boolean conectado = true;



            Mensagem msg = null;

            /*      if(j.size() == 0){
            System.out.println("Cliente" + msg.corpo + "conectou no servidor...");
            this.j.add(new Jogador(msg.corpo, saida));

            if (j.size() == 2) {

            System.out.println("Nome cliente 1: " + j.get(0).getNome());
            System.out.println("Nome cliente 2: " + j.get(1).getNome());

            for (ObjectOutputStream s : outrosClientes) {

            if (s != saida) {

            s.writeObject(new Mensagem(14, j.get(1).getNome()));
            s.flush();
            s.reset();
            } else {

            s.writeObject(new Mensagem(14, j.get(0).getNome()));
            s.flush();
            s.reset();
            }
            }
            }
            }
             *
             */





            while (conectado) {


                msg = (Mensagem) entrada.readObject();

                System.out.println("Servidor recebeu mensagem: " + msg.codigo);

                switch (msg.codigo) {
                    case 10: // conexao dos jogadores no servidor

                        if (j.size() == 0) { // primeiro jogador se conectando

                            System.out.println("Cliente " + msg.corpo + " conectou no servidor...");
                            this.j.add(new Jogador(msg.corpo, saida));
                            saida.writeObject(new Mensagem(45, ""));

                        } else { // segundo jogador se conectando no servidor

                            System.out.println("Cliente " + msg.corpo + " conectou no servidor...");
                            this.j.add(new Jogador(msg.corpo, saida));
                            saida.writeObject(new Mensagem(46, this.j.get(0).getNome()));
                        }
                        System.out.println("saiu do case 10");
                        break;

                    case 51: // mandando nome do oponente para cada cliente e mandando as cartas iniciais

                        for (ObjectOutputStream s : outrosClientes) {

                            if (s != saida) {
                                s.writeObject(new Mensagem(52, j.get(1).getNome()));

                            } else {

                                s.writeObject(new Mensagem(51, j.get(0).getNome()));

                                s.writeObject(new Mensagem(522, ""));

                                for (ObjectOutputStream sa : outrosClientes) {

                                    if (sa != saida) {
                                        sa.writeObject(l.mandarCartasCliente1());
                                        sa.writeObject(new Mensagem(444, ""));
                                    } else {

                                        sa.writeObject(l.mandarCartasCliente2());
                                    }
                                }
                            }
                        }

                        break;

                    case 15:

                        for (ObjectOutputStream s : outrosClientes) {

                            if (s != saida) {

                                s.writeObject(l.mandarCartasCliente2());
                                s.flush();
                                s.reset();
                            } else {

                                s.writeObject(l.mandarCartasCliente1());

                                s.flush();
                                s.reset();

                            }
                        }

                        break;

                    case 121: ///////////////////////////////////////////////


                       // for (ObjectOutputStream s : outrosClientes) {

                        //    if (s == saida) {
                        //        l.vezJogUmNaRodada = true;
                        //    } else {
                         //       l.vezJogUmNaRodada = false;
                        //    }
                        //    break;
                    //    }

                        if (l.vezJogUm == true) { // este if serve para saber de quem é a vez de começar
                            System.out.println("---------------entrou no if do case 121-----------------");
                            // tratamento para o jogador 1 iniciar a partida (recebe a mensagem com a primeira carta enviada)
                            if (l.rodada == 1) {
                                System.out.println("entrou no l.rodada = 1");
                                for (ObjectOutputStream s : outrosClientes) {

                                    if (s == saida) {

                                        System.out.println("entrou no if da rodada 1");
                                        this.j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                        l.primeiraCartaJogador1 = msg.corpo;
                                        l.vezJogUmNaRodada = false;
                                        break;
                                    } else {
                                        System.out.println("entrou no else da rodada 1");
                                        //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                        l.primeiraCartaJogador2 = msg.corpo;
                                        this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);

                                        if (a == 0 || a == 1) {

                                            if (a == 0) {
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "A rodada empatou, espere seu oponente jogar"));
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "A rodada empatou. Escolha uma carta novamente"));
                                                l.embuxou = true;
                                                l.vezJogUmNaRodada = true;
                                            }

                                            if (a == 1) {
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada, aguarde ele jogar"));
                                                this.j.get(0).saida.writeObject(new Mensagem(567, msg.corpo));
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada, Por favor jogue"));
                                                l.vezJogUmNaRodada = true;
                                            }
                                            l.quemComeca = 1;
                                        } else {// jogador 2 ganhou

                                            this.j.get(1).saida.writeObject(new Mensagem(611, "Voce levou a rodada. Escolha uma carta"));
                                            this.j.get(0).saida.writeObject(new Mensagem(612, "Seu oponente levou a rodada, aguarde ele jogar"));
                                            this.j.get(0).saida.writeObject(new Mensagem(566, msg.corpo));
                                            l.quemComeca = 2;
                                            l.vezJogUmNaRodada = false;
                                        }


                                        l.rodada++;
                                        break;
                                    }
                                }
                                break;
                            }


                            if (l.rodada == 2) {
                                System.out.println("entrou na segunda rodada");
                                if (l.quemComeca == 1) {
                                    System.out.println("quem comeca = 1");
                                    for (ObjectOutputStream s : outrosClientes) {

                                        if (s == saida) {
                                            System.out.println("entrou no if da segunda rodada");
                                            this.j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                            l.primeiraCartaJogador1 = msg.corpo;
                                            l.vezJogUmNaRodada = false;
                                            break;

                                        } else {
                                            System.out.println("entrou no else da segunda rodada");
                                            //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador2 = msg.corpo;
                                            this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);



                                            if (a == 0) {
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "A rodada empatou, espere seu oponente jogar"));
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "A rodada empatou. Escolha uma carta novamente"));
                                                this.j.get(0).saida.writeObject(new Mensagem(567, msg.corpo));
                                                l.vezJogUmNaRodada = true;
                                                l.embuxou = true;
                                                l.rodada++;
                                                l.quemComeca = 1;
                                            }

                                            if (a == 1) {
                                                System.out.println("jog lucas ganhou");
                                                l.embaralhar();
                                                j.get(0).setPontos(1);
                                                System.out.println(j.get(0).getPontos());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.atualizaPlacar(); // atualizando placar TESTE
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada, começe a proxima!"));
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = false;
                                                l.rodada = 1;
                                                l.embuxou = false;
                                                l.vezJogUmNaRodada = false;
                                            }

// jogador 2 ganhou

                                            if (a == 2 && l.embuxou == false) {

                                                this.j.get(1).saida.writeObject(new Mensagem(611, "Voce levou a rodada. Escolha uma carta"));
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "Seu oponente levou a rodada, aguarde ele jogar"));
                                                l.quemComeca = 2;
                                                l.rodada++;
                                                l.vezJogUmNaRodada = false;
                                            }

                                            if (a == 2 && l.embuxou == true) {
                                                
                                                l.embaralhar();
                                                j.get(1).setPontos(1);
                                                System.out.println(j.get(1).getPontos());
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                this.atualizaPlacar();
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = false;
                                                l.rodada = 1;
                                                l.embuxou = false;
                                                l.vezJogUmNaRodada = false;
                                            }

                                            break;
                                        }
                                    }
                                    break;
                                }



                                if (l.quemComeca == 2) {
                                    System.out.println("quem comeca = 2");
                                    for (ObjectOutputStream s : outrosClientes) {

                                        if (s != saida) {
                                            System.out.println("entrou no if da segunda rodada do quem começa = 2");
                                            this.j.get(0).saida.writeObject(new Mensagem(567, msg.corpo));
                                            this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                            l.primeiraCartaJogador2 = msg.corpo;
                                            l.vezJogUmNaRodada = true;
                                            break;

                                        } else {
                                            System.out.println("entrou no else da segunda rodada quem começa = 2");
                                            //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador1 = msg.corpo;
                                            this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);



                                            if (a == 0) {
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "A rodada empatou, espere seu oponente jogar"));
                                                this.j.get(1).saida.writeObject(new Mensagem(611, "A rodada empatou. Escolha uma carta novamente"));
                                                l.embuxou = false;
                                                l.rodada++;
                                                l.quemComeca = 2;
                                                l.vezJogUmNaRodada = false;
                                            }

                                            if (a == 1) {
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Voce levou a rodada. Escolha uma carta"));
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Seu oponente levou a rodada, aguarde ele jogar"));
                                                l.embuxou = false;
                                                l.quemComeca = 1;
                                                l.rodada++;
                                                l.vezJogUmNaRodada = true;
                                            }

                                            // jogador 2 ganhou

                                            if (a == 2) {

                                                System.out.println("jog fabio ganhou");
                                                l.embaralhar();
                                                j.get(1).setPontos(1);
                                                System.out.println(j.get(1).getPontos());
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                this.atualizaPlacar();
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = false;
                                                l.rodada = 1;
                                                l.embuxou = false;
                                                l.vezJogUmNaRodada = false;

                                            }

                                            break;
                                        }
                                    }
                                    break;
                                }


                            }

                            // terceira rodada


                            if (l.rodada == 3) {
                                System.out.println("entrou na l.rodada 3");


                                if (l.quemComeca == 1) { // case para quando o jogador 1
                                    System.out.println("l.quemComeca == 1");
                                    for (ObjectOutputStream s : outrosClientes) {

                                        if (s == saida) {

                                            System.out.println("entrou no if da rodada 3");
                                            this.j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador1 = msg.corpo;
                                            l.vezJogUmNaRodada = false;
                                        } else {

                                            System.out.println("entrou no else da segunda rodada");
                                            //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador2 = msg.corpo;
                                            this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);


                                            if (a == 0) { // se as duas cartas na terceira rodada forem iguais

                                                int b = l.comparaRodada3(l.primeiraCartaJogador1, l.primeiraCartaJogador2);

                                                if (b == 1) {
                                                    
                                                    l.embaralhar();
                                                    j.get(0).setPontos(1);
                                                    System.out.println(j.get(0).getPontos());
                                                    this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                    this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                    this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                    this.atualizaPlacar();
                                                    this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada, começe a proxima!"));
                                                    this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                    this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                    l.vezJogUm = false;
                                                    l.rodada = 1;
                                                    l.embuxou = false;
                                                    this.a = 1; // para saber quem levou no truco
                                                }
                                                if (b == 2) {

                                                    
                                                    l.embaralhar();
                                                    j.get(1).setPontos(1);
                                                    System.out.println(j.get(1).getPontos());
                                                    this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                    this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                    this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                    this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                    this.atualizaPlacar();
                                                    this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                    this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                    l.vezJogUm = false;
                                                    l.rodada = 1;
                                                    l.embuxou = false;
                                                    this.a = 2;
                                                }
                                                l.vezJogUmNaRodada = false;
                                            }

                                            if (a == 1) {
                                                System.out.println("jog lucas ganhou");
                                                l.embaralhar();
                                                j.get(0).setPontos(1);
                                                System.out.println(j.get(0).getPontos());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.atualizaPlacar();
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada, começe a proxima!"));
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = false;
                                                l.rodada = 1;
                                                l.embuxou = false;
                                                l.vezJogUmNaRodada = false;
                                            }

                                            if (a == 2) {// jogador 2 ganhou

                                                
                                                l.embaralhar();
                                                j.get(1).setPontos(1);
                                                System.out.println(j.get(1).getPontos());
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                this.atualizaPlacar();
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = false;
                                                l.rodada = 1;
                                                l.embuxou = false;
                                                l.vezJogUmNaRodada = false;

                                            }

                                            break;


                                        }
                                        break;

                                    }

                                }
// rodada 3
                                if (l.quemComeca == 2) {

                                    for (ObjectOutputStream s : outrosClientes) {

                                        if (s != saida) {

                                            System.out.println("entrou no if da rodada 3");
                                            this.j.get(0).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador2 = msg.corpo;
                                            l.vezJogUmNaRodada = true;
                                        } else {

                                            System.out.println("entrou no else da segunda rodada");
                                            //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador1 = msg.corpo;
                                            this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);

                                            if (a == 0) { // se as duas cartas na terceira rodada sao iguais

                                                int b = l.comparaRodada3(l.primeiraCartaJogador1, l.primeiraCartaJogador2);

                                                if (b == 1) {
                                                   
                                                    l.embaralhar();
                                                    j.get(0).setPontos(1);
                                                    System.out.println(j.get(0).getPontos());
                                                    this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                    this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                    this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                    this.atualizaPlacar();
                                                    this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada, começe a proxima!"));
                                                    this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                    this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                    l.vezJogUm = false;
                                                    l.rodada = 1;
                                                    l.embuxou = false;
                                                    this.a = 1;
                                                    l.vezJogUmNaRodada = false;
                                                }
                                                if (b == 2) {

                                                    
                                                    l.embaralhar();
                                                    j.get(1).setPontos(1);
                                                    System.out.println(j.get(1).getPontos());
                                                    this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                    this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                    this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                    this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                    this.atualizaPlacar();
                                                    this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                    this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                    l.vezJogUm = false;
                                                    l.rodada = 1;
                                                    l.embuxou = false;
                                                    this.a = 2;
                                                    l.vezJogUmNaRodada = false;
                                                }
                                            }


                                            if (a == 1) {
                                                
                                                l.embaralhar();
                                                j.get(0).setPontos(1);
                                                System.out.println(j.get(0).getPontos());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.atualizaPlacar();
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada, começe a proxima!"));
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = false;
                                                l.rodada = 1;
                                                l.vezJogUmNaRodada = false;
                                            }

                                            if (a == 2) {// jogador 2 ganhou


                                                
                                                l.embaralhar();
                                                j.get(1).setPontos(1);
                                                System.out.println(j.get(1).getPontos());
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.atualizaPlacar();
                                                this.j.get(1).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = false;
                                                l.rodada = 1;
                                                l.embuxou = false;
                                                l.vezJogUmNaRodada = false;

                                            }

                                            break;


                                        }

                                        break;
                                    }

                                }


                            }

                        } else {
                            // ------------------sempre cairá no else quando for a vez do jogador 2 iniciar a rodada -----------------------------

                            System.out.println("-------- entrou no else do case 121---------");
                            // tratamento para o jogador 1 iniciar a partida (recebe a mensagem com a primeira carta enviada)
                            if (l.rodada == 1) {
                                System.out.println("entrou no l.rodada = 1");
                                for (ObjectOutputStream s : outrosClientes) {

                                    if (s != saida) {

                                        System.out.println("entrou no if da rodada 1");
                                        this.j.get(0).saida.writeObject(new Mensagem(567, msg.corpo));
                                        l.primeiraCartaJogador2 = msg.corpo;
                                        l.vezJogUmNaRodada = true;
                                        break;
                                    } else {
                                        System.out.println("entrou no else da rodada 1");
                                        //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                        l.primeiraCartaJogador1 = msg.corpo;
                                        this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);



                                        if (a == 0) {
                                            this.j.get(0).saida.writeObject(new Mensagem(612, "A rodada empatou, espere seu oponente jogar"));
                                            this.j.get(1).saida.writeObject(new Mensagem(611, "A rodada empatou. Escolha uma carta novamente"));
                                            l.embuxou = true;
                                            l.quemComeca = 2;
                                            l.vezJogUmNaRodada = false;
                                        }

                                        if (a == 1) {
                                            this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada, aguarde ele jogar"));
                                            this.j.get(1).saida.writeObject(new Mensagem(566, msg.corpo));
                                            this.j.get(0).saida.writeObject(new Mensagem(611, "Voce levou a rodada. Jogue"));
                                            l.quemComeca = 1;
                                            l.vezJogUmNaRodada = true;
                                        }

                                        if (a == 2) {// jogador 2 ganhou

                                            this.j.get(1).saida.writeObject(new Mensagem(611, "Voce levou a rodada. Escolha uma carta"));
                                            this.j.get(0).saida.writeObject(new Mensagem(612, "Seu oponente levou a rodada, aguarde ele jogar"));
                                            l.quemComeca = 2;
                                            l.vezJogUmNaRodada = false;
                                        }


                                        l.rodada++;
                                        break;
                                    }

                                }
                                break;
                            }



                            if (l.rodada == 2) {
                                System.out.println("entrou na segunda rodada");
                                if (l.quemComeca == 1) {

                                    System.out.println("quem comeca = 1");

                                    for (ObjectOutputStream s : outrosClientes) {

                                        if (s == saida) {
                                            System.out.println("entrou no if da segunda rodada");
                                            this.j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            this.j.get(0).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                            l.primeiraCartaJogador1 = msg.corpo;
                                            l.vezJogUmNaRodada = false;
                                            break;

                                        } else {
                                            System.out.println("entrou no else da segunda rodada");
                                            //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador2 = msg.corpo;
                                            this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);



                                            if (a == 0) {
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "A rodada empatou, espere seu oponente jogar"));
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "A rodada empatou. Escolha uma carta novamente"));
                                                l.embuxou = true;
                                                l.rodada++;
                                                l.quemComeca = 1;
                                                l.vezJogUmNaRodada = true;
                                            }

                                            if (a == 1 && l.embuxou == true) {
                                                System.out.println("jog lucas ganhou");
                                                l.embaralhar();
                                                j.get(0).setPontos(1);
                                                System.out.println(j.get(0).getPontos());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.atualizaPlacar();
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada inteira!"));

                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = true;
                                                l.rodada = 1;
                                                l.vezJogUmNaRodada = true;

                                            }


                                            // jogador 2 ganhou

                                            if (a == 2 && l.embuxou == false) {

                                                this.j.get(1).saida.writeObject(new Mensagem(611, "Voce levou a rodada. Escolha uma carta"));
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "Seu oponente levou a rodada, aguarde ele jogar"));
                                                l.quemComeca = 2;
                                                l.rodada++;
                                                l.vezJogUmNaRodada = false;
                                            }

                                            if (a == 2 && l.embuxou == true) {
                                                
                                                l.embaralhar();
                                                j.get(1).setPontos(1);
                                                System.out.println(j.get(0).getPontos());
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.atualizaPlacar();

                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = true;
                                                l.rodada = 1;
                                                l.embuxou = false;
                                                l.vezJogUmNaRodada = true;
                                            }

                                            break;
                                        }
                                    }
                                    break;
                                }

                                if (l.quemComeca == 2) {
                                    System.out.println("quem comeca = 2");
                                    for (ObjectOutputStream s : outrosClientes) {

                                        if (s != saida) {
                                            System.out.println("entrou no if da segunda rodada do quem começa = 2");
                                            this.j.get(0).saida.writeObject(new Mensagem(567, msg.corpo));
                                            this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                            l.primeiraCartaJogador2 = msg.corpo;
                                            l.vezJogUmNaRodada = true;
                                            break;

                                        } else {
                                            System.out.println("entrou no else da segunda rodada quem começa = 2");
                                            //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador1 = msg.corpo;
                                            this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);



                                            if (a == 0) {
                                                this.j.get(0).saida.writeObject(new Mensagem(612, "A rodada empatou, espere seu oponente jogar"));
                                                this.j.get(1).saida.writeObject(new Mensagem(611, "A rodada empatou. Escolha uma carta novamente"));
                                                l.embuxou = true;
                                                l.rodada++;
                                                l.quemComeca = 2;
                                                l.vezJogUmNaRodada = false;
                                            }

                                            if (a == 1 && l.embuxou == false) {
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Seu oponente levou a rodada, aguarde ele jogar"));
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada"));
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Voce levou a rodada"));
                                                this.j.get(1).saida.writeObject(new Mensagem(566, msg.corpo));
                                                l.rodada++;
                                                l.quemComeca = 1;
                                                l.vezJogUmNaRodada = true;
                                            }

                                            if (a == 1 && l.embuxou == true) {
                                                System.out.println("jog lucas ganhou");
                                                l.embaralhar();
                                                j.get(0).setPontos(1);
                                                System.out.println(j.get(0).getPontos());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());

                                                this.atualizaPlacar();
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada inteira!"));
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = true;
                                                l.rodada = 1;

                                                l.vezJogUmNaRodada = true;

                                            }

                                            if (a == 2) {// jogador 2 ganhou
                                                
                                                l.embaralhar();
                                                j.get(1).setPontos(1);
                                                System.out.println(j.get(1).getPontos());
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                this.atualizaPlacar();
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = true;
                                                l.rodada = 1;
                                                l.vezJogUmNaRodada = true;
                                            }

                                            break;
                                        }
                                    }
                                    break;
                                }


                            }

                            // terceira rodada


                            if (l.rodada == 3) {
                                System.out.println("entrou na l.rodada 3");


                                if (l.quemComeca == 1) { // case para quando o jogador 1

                                    for (ObjectOutputStream s : outrosClientes) {

                                        if (s == saida) {

                                            System.out.println("entrou no if da rodada 3");
                                            this.j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            this.j.get(0).saida.writeObject(new Mensagem(111, "Aguarde seu oponente jogar"));
                                            l.primeiraCartaJogador1 = msg.corpo;
                                            l.vezJogUmNaRodada = false;
                                        } else {

                                            System.out.println("entrou no else da segunda rodada");
                                            //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador2 = msg.corpo;
                                            this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);



                                            if (a == 1) {
                                                System.out.println("jog lucas ganhou");
                                                l.embaralhar();
                                                j.get(0).setPontos(1);
                                                System.out.println(j.get(0).getPontos());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.atualizaPlacar();
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada, começe a proxima!"));
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = true;
                                                l.rodada = 1;
                                                l.vezJogUmNaRodada = true;
                                            }

                                            if (a == 2) {// jogador 2 ganhou


                                                
                                                l.embaralhar();
                                                j.get(1).setPontos(1);
                                                System.out.println(j.get(0).getPontos());
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.atualizaPlacar();
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = true;
                                                l.rodada = 1;
                                                l.embuxou = false;
                                                l.vezJogUmNaRodada = true;
                                            }

                                            break;


                                        }

                                        break;
                                    }

                                }

// rodada 3
                                if (l.quemComeca == 2) {

                                    for (ObjectOutputStream s : outrosClientes) {

                                        if (s != saida) {

                                            System.out.println("entrou no if da rodada 3");
                                            this.j.get(0).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador2 = msg.corpo;
                                            l.vezJogUmNaRodada = true;
                                        } else {

                                            System.out.println("entrou no else da segunda rodada");
                                            //j.get(1).saida.writeObject(new Mensagem(567, msg.corpo));
                                            l.primeiraCartaJogador1 = msg.corpo;
                                            this.a = l.ganhadorRodada(l.primeiraCartaJogador1, l.primeiraCartaJogador2);



                                            if (a == 1) {
                                                System.out.println("jog lucas ganhou");
                                                l.embaralhar();
                                                j.get(0).setPontos(1);
                                                System.out.println(j.get(0).getPontos());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.atualizaPlacar();
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada, começe a proxima!"));

                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = true;
                                                l.rodada = 1;
                                                l.vezJogUmNaRodada = true;


                                            }
                                            if (a == 2) {// jogador 2 ganhou


                                                
                                                l.embaralhar();
                                                j.get(1).setPontos(1);
                                                System.out.println(j.get(1).getPontos());
                                                this.j.get(1).saida.writeObject(new Mensagem(111, "Voce levou a rodada inteira!"));
                                                this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                                this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                                this.j.get(0).saida.writeObject(new Mensagem(111, "Seu oponente levou a rodada"));
                                                this.j.get(1).saida.writeObject(new Mensagem(612, "Espere seu oponente jogar"));
                                                this.atualizaPlacar();
                                                this.j.get(0).saida.writeObject(new Mensagem(611, "Escolha uma carta"));
                                                l.vezJogUm = true;
                                                l.rodada = 1;
                                                l.embuxou = false;
                                                l.vezJogUmNaRodada = true;

                                            }

                                        }

                                        break;


                                    }

                                }

                            }

                        }


                        break; // break do case 121



                    case 900:  // quando clientes apertarem trucar cai aqui.
                        for (ObjectOutputStream s : outrosClientes) {

                            if (s == saida) {
                                this.j.get(1).saida.writeObject(new Mensagem(800, ""));


                            } else {
                                this.j.get(0).saida.writeObject(new Mensagem(800, ""));


                            }
                            break;
                        }

                        break;







                    case 901: // quando clientes apertarem aceitar cai aqui.

                        this.j.get(0).saida.writeObject(new Mensagem(600, ""));
                        this.j.get(1).saida.writeObject(new Mensagem(600, ""));

                        for (ObjectOutputStream s : outrosClientes) {

                            if (s != saida) {
                                System.out.println("entrou no aceitou truco");
                                // this.j.get(0).saida.writeObject(new Mensagem(700, ""));
                                if (l.vezJogUmNaRodada == true) {
                                    this.j.get(0).saida.writeObject(new Mensagem(611, "Seu oponente aceitou o truco, Jogue"));
                                    this.j.get(1).saida.writeObject(new Mensagem(612, "Aguarde seu oponente jogar"));
                                } else {
                                    this.j.get(1).saida.writeObject(new Mensagem(611, "Voce aceitou o truco, Jogue"));
                                    this.j.get(0).saida.writeObject(new Mensagem(612, "Aguarde seu oponente jogar"));
                                }
                                l.trucado = true;
                                l.jog1Trucou = true;
                            } else {
                                if (l.vezJogUmNaRodada == true) {
                                    this.j.get(0).saida.writeObject(new Mensagem(611, "Voce aceitou o truco, Jogue"));
                                    this.j.get(1).saida.writeObject(new Mensagem(612, "Aguarde seu oponente jogar"));
                                } else {
                                    this.j.get(1).saida.writeObject(new Mensagem(611, "Seu oponente aceitou o truco, Jogue"));
                                    this.j.get(0).saida.writeObject(new Mensagem(612, "Aguarde seu oponente jogar"));
                                }
                                l.trucado = true;
                                l.jog2Trucou = true;
                            }
                            break;
                        }


                        break;

                    case 902: // quando clientes apertarem correr cai aqui

                        for (ObjectOutputStream s : outrosClientes) {

                            if (s == saida) {

                                if ((l.trucado == false) && (l.truco6 == false) && (l.truco9 == false)) {
                                    this.j.get(1).setPontos(1);
                                    this.j.get(1).saida.writeObject(new Mensagem(111, "Seu Oponente correu"));
                                    this.j.get(0).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));
                                    this.j.get(1).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));
                                    l.embaralhar();

                                    this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                    this.j.get(0).saida.writeObject(l.mandarCartasCliente1());

                                }


                                if (l.trucado) {
                                    this.j.get(1).setPontos(3);
                                    this.j.get(1).saida.writeObject(new Mensagem(111, "Seu Oponente correu"));
                                    this.j.get(0).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));
                                    this.j.get(1).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));

                                    l.embaralhar();
                                    this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                    this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                    l.trucado = false;

                                }
                                if (l.truco6) {
                                }
                                if (l.truco9) {
                                }

                            } else {

                                if ((l.trucado == false) && (l.truco6 == false) && (l.truco9 == false)) {
                                    this.j.get(0).setPontos(1);
                                    this.j.get(0).saida.writeObject(new Mensagem(111, "Seu Oponente correu"));
                                    this.j.get(0).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));
                                    this.j.get(1).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));

                                    l.embaralhar();
                                    this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                    this.j.get(0).saida.writeObject(l.mandarCartasCliente1());

                                }

                                if (l.trucado) {
                                    this.j.get(0).setPontos(3);
                                    this.j.get(0).saida.writeObject(new Mensagem(111, "Seu Oponente correu"));
                                    this.j.get(0).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));
                                    this.j.get(1).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));

                                    l.embaralhar();
                                    this.j.get(1).saida.writeObject(l.mandarCartasCliente2());
                                    this.j.get(0).saida.writeObject(l.mandarCartasCliente1());
                                    l.trucado = false;

                                }
                                if (l.truco6) {
                                }
                                if (l.truco9) {
                                }
                            }

                            if (l.vezJogUm == true) { // este if else é usado para saber de quem é a vez de começar
                                l.rodada = 1;
                                l.vezJogUm = false;
                                this.j.get(1).saida.writeObject(new Mensagem(611, "Sua vez, jogue"));
                                this.j.get(0).saida.writeObject(new Mensagem(612, "Aguarde seu oponente jogar"));
                            } else {
                                l.rodada = 1;
                                l.vezJogUm = true;
                                this.j.get(0).saida.writeObject(new Mensagem(611, "Sua vez, jogue"));
                                this.j.get(1).saida.writeObject(new Mensagem(612, "Aguarde seu oponente jogar"));
                            }


                            this.verificaGanhadorJogo(); // verificando se alguem chegou a 12 pontos.

                            break;
                        }


                        break;


                    case 903:
                        for (ObjectOutputStream s : outrosClientes) {

                            if (s != saida) {
                            }
                        }


                        break;

                }




                /*


                String nomeCliente = (String) entrada.readObject();
                System.out.println("Nao fica esperando");
                while (conectado) {
                String linha = (String) entrada.readObject();
                System.out.println(nomeCliente + "> " + linha);

                if (linha.equals("FIM")) {
                conectado = false;
                saida.writeObject("FIM");
                outrosClientes.remove(saida);
                } else {
                for (ObjectOutputStream outraSaida : outrosClientes) {

                if (saida != outraSaida) {
                outraSaida.writeObject(nomeCliente + "> " + linha);
                }
                }
                }
                }*/
                // fechando os fluxos e a conexao

            }


            saida.close();
            entrada.close();
            conexao.close();

            /*

            if (y == 1) {
            //saida.writeObject(l.mandarCartasCliente1());
            Mensagem n = new Mensagem();
            n.corpo = "OLA JOGADOR, ESPERE O SEU OPONENTE.";
            saida.writeObject(n);

            } else {

            // saida.writeObject(l.mandarCartasCliente2());
            Mensagem a = new Mensagem();
            a.corpo = "BEM VINDO JOGADOR 2.";
            saida.writeObject(a);



            }

             */


        } catch (Exception ex) {
            System.err.println("Erro sockets: " + ex.toString());
        }
    }

    public void atualizaPlacar() { // metodo usado para mandar para os dois clientes o placar ao fim de cada rodada

        try {
            if (l.trucado) {

                if (this.a == 1) {// a variavel a sempre indica quem foi o ultimo jogador que ganhou a rodada retorna sempre 1 ou 2
                    j.get(0).setPontos(2);
                }

                if (this.a == 2) {
                    j.get(1).setPontos(2);
                }

                l.trucado = false;
                l.jog2Trucou = false;
                l.jog2Trucou = false;

            }


            if (l.truco6) {

                if (this.a == 1) {// a variavel a sempre indica quem foi o ultimo jogador que ganhou a rodada retorna sempre 1 ou 2
                    j.get(0).setPontos(5);
                }

                if (this.a == 2) {
                    j.get(1).setPontos(5);
                }

                l.truco6 = false;
                l.jog2Trucou = false;
                l.jog2Trucou = false;
            }




            this.j.get(0).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));
            this.j.get(1).saida.writeObject(new Mensagem(734, j.get(0).getPontos() + ":" + j.get(1).getPontos()));

            if (j.get(0).getPontos().equals(12)) {
            }



            if (j.get(1).getPontos().equals(12)) {
            }

            this.verificaGanhadorJogo(); // metodo para verificar o ganhador do jogo

        } catch (Exception ex) {
            System.err.println("Erro sockets: " + ex.toString());
        }
    }

    public void verificaGanhadorJogo() {
        try {
            if (this.j.get(0).getIntPontos() >= 12) {

                this.j.get(0).saida.writeObject(new Mensagem(999, "Sua vez, jogue"));
                this.j.get(1).saida.writeObject(new Mensagem(998, "Sua vez, jogue"));
            }

            if (this.j.get(1).getIntPontos() >= 12) {

                this.j.get(1).saida.writeObject(new Mensagem(999, "Sua vez, jogue"));
                this.j.get(0).saida.writeObject(new Mensagem(998, ""));
            }
            
        } catch (Exception ex) {
            System.err.println("Erro sockets: " + ex.toString());
        }
    }
}
