package jogo;

import Servidor.Mensagem;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class ClienteThread extends Thread {

    private Principal pai;
    private ObjectOutputStream saida;
    private ObjectInputStream entrada;
    private String nome;
    private Mesa m;
    private String ip;

    ClienteThread(Principal aThis, String n, Mesa m, String IPSERVIDOR) {
        this.pai = aThis;
        this.nome = n;
        this.m = m;
        this.ip = IPSERVIDOR;

    }

    public void enviarMensagem(Mensagem msg) {
        try {
            this.saida.writeObject(msg);
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }
    }

    public void trucar(Mensagem msg) {
        try {
            this.saida.writeObject(msg);
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }
    }

    public void aceitar(Mensagem msg) {
        try {
            this.saida.writeObject(msg);
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }
    }

    public void correr(Mensagem msg) {
        try {
            this.saida.writeObject(msg);
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }
    }

    public void aumentar(Mensagem msg) {
        try {
            this.saida.writeObject(msg);
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }
    }

    @Override
    public void run() {
        Socket conexao;

        // String ip = "127.0.0.1";

        try {
            conexao = new Socket(ip, 1234);
            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());
            boolean conectado = true;


            saida.writeObject(new Mensagem(10, this.nome));

            while (conectado) {

                Mensagem msg = (Mensagem) entrada.readObject();

                System.out.println("Cliente recebeu mensagem: " + msg.codigo);

                switch (msg.codigo) {
                    case 14:

                        pai.adicionarLinha("Nome do seu oponente é " + msg.corpo);
                        saida.writeObject(new Mensagem(15, ""));

                        break;

                    case 1:

                        pai.limpaMesa();
                        pai.adicionaCartas();
                        Thread.sleep(100);
                        pai.receberCartasIniciais(msg.corpo);



                        break;

                    case 2:


                        break;

                    case 45:
                        pai.adicionarLinha("Espere seu oponente conectar"); // somente usado para o primeiro cliente que se conectar
                        pai.setNomeJog1("Voce");
                        break;

                    case 46:
                        pai.adicionarLinha("aguarde as cartas na mesa");

                        saida.writeObject(new Mensagem(51, ""));     // somente cliente 2 recebe. agora o cliente 2 avisa ao servidor que o jogo pode começar.
                        break;

                    case 52: //somente cliente 1 recebe. (nome do seu oponente)
                        pai.adicionarLinha("Seu oponente é o " + msg.corpo + " BOA SORTE!");
                        pai.setNomeJog2(msg.corpo);
                        pai.voceCliente1(true);
                        break;

                    case 51: // somente cliente 2 recebe. (nome do seu oponente, que no caso é o jog 1)
                        pai.adicionarLinha("Seu oponente é o " + msg.corpo + " BOA SORTE!");
                        pai.setNomeJog1(msg.corpo);
                        pai.setNomeJog2("Voce");
                        break;

                    case 444:
                        pai.adicionarLinha("Escolha sua carta");
                        this.habilitaBotaoCartas();
                        break;

                    case 522:
                        pai.adicionarLinha("Espere seu oponente escolhar a carta");
                        break;

                    case 610: // cliente recebendo carta do oponente
                        pai.oponenteMeio.viraCarta(msg.corpo); // mostra para o cliente 2 a carta que o cliente 1 jogou
                        pai.redesenharMesa();
                        pai.adicionarLinha("Sua vez. Escolha uma carta"); //passa a vez da jogada para o cliente 2
                        this.habilitaBotaoCartas();
                        break;

                    case 611:
                        pai.redesenharMesa();
                        pai.adicionarLinha(msg.corpo);
                        this.habilitaBotaoCartas();
                        break;

                    case 612:
                        pai.redesenharMesa();
                        pai.adicionarLinha(msg.corpo);
                        this.desabilitaBotaoCartas();
                        break;

                    case 567:
                        System.out.println("entrou no 567 do cliente 2");
                        
                        pai.deletarCartaOponenteDoArray();
                        pai.cartaOponenteAndaNaTela(msg.corpo);
                        pai.redesenharMesa();
                        this.habilitaBotaoCartas();
                        pai.adicionarLinha("Sua vez. Escolha uma carta");
                        break;

                    case 566:// cliente  recebe depois de levar a otra rodada

                        pai.deletarCartaOponenteDoArray();
                        pai.cartaOponenteAndaNaTela(msg.corpo);
                        pai.redesenharMesa();
                        this.desabilitaBotaoCartas();

                        break;

                    case 111: // usado somente para adicionar uma linha na INFO de algum cliente
                        pai.adicionarLinha(msg.corpo);
                        break;


                    case 734:  // atualiza o placar do jogo
                        String vetCarta[] = msg.corpo.split(":");
                        pai.setPontosJog1(vetCarta[0]);
                        pai.setPontosJog2(vetCarta[1]);
                        break;


                    case 800: // pergunta para cliente 1 ou 2 se aceita o truco
                        this.desabilitaBotaoCartas();
                        pai.jBAceitar.setEnabled(true);
                        pai.jBTrucar.setEnabled(false);
                        pai.jBAumentar.setEnabled(true);
                        pai.jBCorrer.setEnabled(true);
                        pai.adicionarLinha("Seu oponente pediu truco!");
                        break;


                    case 600: // ambos clientes recebem essa mensagem apos o servidor receber mensagem de aceitar truco.
                        pai.jBCorrer.setEnabled(true);
                        break;



                    case 999: // mensagem indicando q o cliente venceu o jogo

                        pai.adicionarLinha("VOCE VENCEU! PARABENS!!!!");
                        pai.adicionarLinha("para jogar novemente efetue uma nova conexão");
                        this.desabilitaTodosBotoes();
                        break;

                    case 998: // mensagem indicando que voce perdeu o jogo

                        pai.adicionarLinha("VOCE PERDEU A PARTIDA.");
                        pai.adicionarLinha("Para jogar novamente efetue uma nova conexão");
                        this.desabilitaTodosBotoes();
                        break;
                }







                // Mensagem r = (Mensagem) entrada.readObject();
                // pai.receberCartasIniciais(r.corpo);
                //pai.adicionarLinha(r.corpo);








                // pai.criaBaralho(m);
                //m.recebaCartasIniciais(mensagem);
                //pai.adicionarLinha(m.corpo);
            /*while (conectado) {

                String linha = (String) entrada.readObject();
                pai.adicionarLinha(linha);
                if (linha.equals("FIM")) {
                conectado = false;
                }
                }*/
                // fechando os fluxos e a conexao


            }

            saida.close();
            entrada.close();
            conexao.close();

        } catch (Exception ex) {
            System.err.println("Erro sockets: " + ex.toString());
        }
    }

    public void habilitaBotaoCartas() {



        if (pai.baralho.contains(pai.meio)) {
            pai.jBEnviarMeio.setEnabled(true);
        } else {
            pai.jBEnviarMeio.setEnabled(false);
        }

        if (pai.baralho.contains(pai.direita)) {
            pai.jBEnviarDireita.setEnabled(true);
        } else {
            pai.jBEnviarDireita.setEnabled(false);
        }
        if (pai.baralho.contains(pai.esquerda)) {
            pai.jBEnviarEsquerda.setEnabled(true);
        } else {
            pai.jBEnviarEsquerda.setEnabled(false);
        }


        // if(pai.meio == null) pai.jBEnviarMeio.setEnabled(false);
        //  if(pai.direita == null) pai.jBEnviarDireita.setEnabled(false);
    }

    public void desabilitaBotaoCartas() {

        pai.jBEnviarEsquerda.setEnabled(false);
        pai.jBEnviarMeio.setEnabled(false);
        pai.jBEnviarDireita.setEnabled(false);

    }

    public void desabilitaTodosBotoes() {

        pai.jBEnviarEsquerda.setEnabled(false);
        pai.jBEnviarMeio.setEnabled(false);
        pai.jBEnviarDireita.setEnabled(false);
        pai.jBAumentar.setEnabled(false);
        pai.jBCorrer.setEnabled(false);
        pai.jBTrucar.setEnabled(false);
        pai.jBAceitar.setEnabled(false);
        pai.limpaMesa();
    }
}
